#include <stdlib.h>

void saxpy(int n, float a, float* x, float* restrict y) {
  #pragma acc data copy(y[0:n]) copyin(x[0:n])
  {
    #pragma acc parallel loop
    for (int i = 0; i < n; ++i)
      y[i] = a * x[i] + y[i];
  }
}

int main(int argc, char* argv[]) {
  int N = 1 << 20;

  float* x = (float*) malloc(N * sizeof(float));
  float* y = (float*) malloc(N * sizeof(float));

  for (int i = 0; i < N; ++i) {
    x[i] = 2.0f;
    y[i] = 1.0f;
  }

  saxpy(N, 2.0f, x, y);

  free(x);
  free(y);

  return 0;
}