    program main
      implicit none
    
      integer, parameter :: N = 2**20;
      integer :: i
      real, dimension(:), allocatable :: x, y
    
      allocate(x(N), y(N))
    
      do i = 1,N
        x(i) = 2.0
        y(i) = 1.0
      end do
    
      call saxpy(N, 2.0, x, y)
    
      deallocate(x, y);
    
      contains
        subroutine saxpy(n, a, x, y)
          real :: x(n), y(n), a
          integer :: n, i
          
          !$acc data copy(y(0:n)) copyin(x(0:n))
          !$acc parallel loop
            do i = 1,n
              y(i) = a * x(i) + y(i)
            end do
          !$acc end parallel loop
          !$acc end data
        end subroutine
    end program