    program main
      implicit none
    
      integer, parameter :: N = 2**20;
      integer :: i
      real, dimension(:), allocatable :: x, y
    
      allocate(x(N), y(N))
    
      do i = 1,N
        x(i) = 2.0
        y(i) = 1.0
      end do
    
      call saxpy(N, 2.0, x, y)
    
      deallocate(x, y);
    
      contains
        subroutine saxpy(n, a, x, y)
          real :: x(n), y(n), a
          integer :: n, i, j
          
          !$omp  target teams distribute parallel do &
          !$omp&        map(to: a, n, x) map(tofrom: y)
            do i = 1,n
              y(i) = a * x(i) + y(i)
            end do
          !$omp end target teams distribute parallel do 
        end subroutine
    end program